/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+,78K0S/KU1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.70 [7 Dec. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "port.h"
#include "watchdogtimer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
unsigned short	ad_data;		/* ADł̎擾l			*/

int	ad_x;
int	ad_y;
int	ad_z;
int	ref_x;
int	ref_y;
int	ref_z;
unsigned char	led[8];

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}

void	matrix_send(unsigned char ad,unsigned char data)
{
unsigned char i;

	P4.0=0;
	for(i=0;i<8;i++){
		wait_time(2);
		P4.1=0;
		wait_time(2);
		if(ad>=0x80){
			P4.2=1;
		}
		else{
			P4.2=0;
		}
		ad=ad<<1;
		wait_time(2);
		P4.1=1;
	}
	for(i=0;i<8;i++){
		wait_time(2);
		P4.1=0;
		wait_time(2);
		if(data>=0x80){
			P4.2=1;
		}
		else{
			P4.2=0;
		}
		data=data<<1;
		wait_time(2);
		P4.1=1;
	}
	wait_time(2);
	P4.0=1;
	wait_time(2);
	P4.2=0;
	wait_time(2);
}
void	matrix_clear(void)
{
unsigned char i;

	P4.0=1;P4.1=0;P4.2=0;
	
	matrix_send(0x0f,0x00);
	
	for(i=1;i<=8;i++){
		matrix_send(i,0x00);
	}
	matrix_send(0x09,0x00);
	matrix_send(0x0a,0x0f);
	matrix_send(0x0b,0x07);
	matrix_send(0x0c,0x01);
}

void	matrix_disp(void)
{
unsigned char i;

	for(i=0;i<8;i++){
		matrix_send(i+1,led[i]);
	}
}

void	led_data_set(unsigned char no)
{
	switch(no){
		case 0:led[0]=0x10;led[1]=0x30;led[2]=0x7f;led[3]=0xff;
				led[4]=0xff;led[5]=0x7f;led[6]=0x30;led[7]=0x10;break;
		case 1:led[0]=0x04;led[1]=0x0e;led[2]=0x1f;led[3]=0xbe;
				led[4]=0xfc;led[5]=0xf8;led[6]=0xf0;led[7]=0xf8;break;
		case 2:led[0]=0x3c;led[1]=0x3c;led[2]=0x3c;led[3]=0x3c;
				led[4]=0xff;led[5]=0x7e;led[6]=0x3c;led[7]=0x18;break;
		case 3:led[0]=0x20;led[1]=0x70;led[2]=0xf8;led[3]=0x7d;
				led[4]=0x3f;led[5]=0x1f;led[6]=0x0f;led[7]=0x1f;break;
		case 4:led[0]=0x08;led[1]=0x0c;led[2]=0xfe;led[3]=0xff;
				led[4]=0xff;led[5]=0xfe;led[6]=0x0c;led[7]=0x08;break;
		case 5:led[0]=0x1f;led[1]=0x0f;led[2]=0x1f;led[3]=0x3f;
				led[4]=0x7d;led[5]=0xf8;led[6]=0x70;led[7]=0x20;break;
		case 6:led[0]=0x18;led[1]=0x3c;led[2]=0x7e;led[3]=0xff;
				led[4]=0x3c;led[5]=0x3c;led[6]=0x3c;led[7]=0x3c;break;
		case 7:led[0]=0xf8;led[1]=0xf0;led[2]=0xf8;led[3]=0xfc;
				led[4]=0xbe;led[5]=0x1f;led[6]=0x0e;led[7]=0x04;break;
		case 8:led[0]=0x00;led[1]=0x18;led[2]=0x3c;led[3]=0x7e;
				led[4]=0x7e;led[5]=0x3c;led[6]=0x18;led[7]=0x00;break;

		case 10:led[0]=0x10;led[1]=0x30;led[2]=0x5f;led[3]=0x81;
				led[4]=0x81;led[5]=0x5f;led[6]=0x30;led[7]=0x10;break;
		case 11:led[0]=0x04;led[1]=0x0a;led[2]=0x11;led[3]=0xa2;
				led[4]=0xc4;led[5]=0x88;led[6]=0x90;led[7]=0xf8;break;
		case 12:led[0]=0x3c;led[1]=0x24;led[2]=0x24;led[3]=0x24;
				led[4]=0xe7;led[5]=0x42;led[6]=0x24;led[7]=0x18;break;
		case 13:led[0]=0x20;led[1]=0x50;led[2]=0x88;led[3]=0x45;
				led[4]=0x23;led[5]=0x11;led[6]=0x09;led[7]=0x1f;break;
		case 14:led[0]=0x08;led[1]=0x0c;led[2]=0xfa;led[3]=0x81;
				led[4]=0x81;led[5]=0xfa;led[6]=0x0c;led[7]=0x08;break;
		case 15:led[0]=0x1f;led[1]=0x09;led[2]=0x11;led[3]=0x23;
				led[4]=0x45;led[5]=0x88;led[6]=0x50;led[7]=0x20;break;
		case 16:led[0]=0x18;led[1]=0x24;led[2]=0x42;led[3]=0xe7;
				led[4]=0x24;led[5]=0x24;led[6]=0x24;led[7]=0x3c;break;
		case 17:led[0]=0xf8;led[1]=0x90;led[2]=0x88;led[3]=0xc4;
				led[4]=0xa2;led[5]=0x11;led[6]=0x0a;led[7]=0x04;break;
		case 18:led[0]=0x00;led[1]=0x18;led[2]=0x24;led[3]=0x42;
				led[4]=0x42;led[5]=0x24;led[6]=0x18;led[7]=0x00;break;

	}
}
unsigned char sens_3d(void)
{
int sa_x,fx;
int sa_y,fy;
int sa_z,fz;
int sa_xy;
int ret;
unsigned char flg;

	flg=0;

	if(ref_x>ad_x){fx=1;sa_x=ref_x-ad_x;}
	else{fx=0;sa_x=ad_x-ref_x;}
	if(ref_y>ad_y){fy=1;sa_y=ref_y-ad_y;}
	else{fy=0;sa_y=ad_y-ref_y;}
	if(ref_z>ad_z){fz=1;sa_z=ref_z-ad_z;}
	else{fz=0;sa_z=ad_z-ref_z;}

	if((fx==0)&&(fy==0)){
		if((sa_x>70)&&(sa_y>70)){ret=1;flg=1;}
		if((sa_x>70)&&(sa_y<=70)){ret=2;flg=1;}
		if((sa_y>70)&&(sa_x<=70)){ret=0;flg=1;}
	}
	if((fx==0)&&(fy==1)){
		if((sa_x>70)&&(sa_y>70)){ret=3;flg=1;}
		if((sa_x>70)&&(sa_y<=70)){ret=2;flg=1;}
		if((sa_y>70)&&(sa_x<=70)){ret=4;flg=1;}
	}
	if((fx==1)&&(fy==1)){
		if((sa_x>70)&&(sa_y>70)){ret=5;flg=1;}
		if((sa_x>70)&&(sa_y<=70)){ret=6;flg=1;}
		if((sa_y>70)&&(sa_x<=70)){ret=4;flg=1;}
	}
	if((fx==1)&&(fy==0)){
		if((sa_x>70)&&(sa_y>70)){ret=7;flg=1;}
		if((sa_x>70)&&(sa_y<=70)){ret=6;flg=1;}
		if((sa_y>70)&&(sa_x<=70)){ret=0;flg=1;}
	}
	if(flg==0){ret=8;}
	if(fz==0){ret=ret+10;}
	return (unsigned char)ret;
}

void main( void )
{
unsigned int	sub;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sens;

	sub=0;
	ref_x=512;
	ref_y=512;
	ref_z=512;

	matrix_clear();
	led_data_set(0);

	/* TODO. add user code */
	while(1){
	
	/* key scan 1 */
		if (P12.2==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/

		if (P12.1==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/


	
		AD_Start(ADChannel0);
		AD_Read(&ad_data);
		ad_x=ad_data;
	
		AD_Start(ADChannel1);
		AD_Read(&ad_data);
		ad_y=ad_data;
	
		AD_Start(ADChannel2);
		AD_Read(&ad_data);
		ad_z=ad_data;

		sens=sens_3d();
		led_data_set(sens);
		if(sub==0){
			matrix_disp();
			sub=50;
		}
		else{
			sub--;
		}

	/* key scan 2 */
		if ((P12.2==0)&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
		}
		/*------------------*/
		if ((P12.1==0)&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
		}
		/*------------------*/

	/* key action */
	
		if((sw1_key==0)&(sw1_rep==0)){
			sw1_rep=1;
			sub=0;
			ref_x=ad_x;
			ref_y=ad_y;

		}
		if((sw2_key==0)&(sw2_rep==0)){
			sw2_rep=1;
			sub=0;
			ref_z=ad_z;

		}

	}
}

